pub mod config;
mod padcontrol;
mod zabbix;

use config::Config;

fn main() {
    // parse arguments
    let matches = config::argparse();

    // load configuration
    let configfile = matches
                        .value_of("config")
                        .unwrap_or("config.json");
    let mut cfg = Config::new();
    cfg.load(&configfile);

    // init/connect to launchpad and clear it
    let (mut canvas, mut poller) = padcontrol::initpad();
    padcontrol::input(&mut canvas, &mut poller);

    // fetch zabbix data
    zabbix::get_zabbix_authtoken(&mut cfg);
    zabbix::get_zabbix_problems(&mut cfg);
    cfg.save(&configfile);
}